// Copyright (c) 2020-2023 Navibyte (https://navibyte.com). All rights reserved.
// Use of this source code is governed by a “BSD-3-Clause”-style license that is
// specified in the LICENSE file.
//
// Docs: https://github.com/navibyte/geospatial

/// Projected and geographic coordinates, and basic transforms.
///
/// This library exports also all classes of `package:geocore/base.dart`.
///
/// Usage: import `package:geocore/coordinates.dart`
library coordinates;

export 'base.dart';

export 'src/coordinates/geographic.dart';
export 'src/coordinates/projected.dart';
export 'src/coordinates/transforms.dart';
